tb.namespace( 'tb.Bootstrap' ).set(
    (function(){

        // variables
        //noinspection SpellCheckingInspection
        var display = function( pSize ){ return [
                pSize + '-block',
                pSize + '-inline',
                pSize + '-inline-block'
            ]; },
            sizes = [
                'xs',
                'sm',
                'md',
                'lg'
            ],
            bootstrapHelpers = {
                'lead': {
                    classPrefix: '',
                    classes: {
                        lead: [
                            'lead'
                        ]
                    }
                },
                'text': {
                    classPrefix: 'text-',
                    classes: {
                        muted: [
                            'muted'
                        ],
                        hide: [
                            'hide'
                        ],
                        capitalize: [
                            'lowercase',
                            'uppercase',
                            'capitalize'
                        ],
                        type: [
                            'primary',
                            'success',
                            'info',
                            'warning',
                            'danger'
                        ]
                    }
                },
                'bg': {
                    classPrefix: 'bg-',
                    classes: {
                        type: [
                            'default',
                            'primary',
                            'success',
                            'info',
                            'warning',
                            'danger'
                        ]
                    }
                },
                'pull': {
                    classPrefix: 'pull-',
                    classes: {
                        type: [
                            'left',
                            'right'
                        ]
                    }
                },
                'push': {
                    classPrefix: 'push-',
                    classes: {
                        type: [
                            'left',
                            'right'
                        ]
                    }
                },
                'center': {
                    classPrefix: 'center-',
                    classes: {
                        type: [
                            'block'
                        ]
                    }
                },
                'clearfix': {
                    classPrefix: '',
                    classes: {
                        type: [
                            'clearfix'
                        ]
                    }
                },
                'show': {
                    classPrefix: '',
                    classes: {
                        type: [
                            'show'
                        ]
                    }
                },
                'sr-only': {
                    classPrefix: 'sr-only-',
                    classes: {
                        type: [
                            'focusable'
                        ]
                    }
                },
                'visible': {
                    classPrefix: 'visible-',
                    classes: {
                        xs: display('xs'),
                        sm: display('sm'),
                        md: display('md'),
                        lg: display('lg'),
                        print: display('print')
                    }
                },
                'hidden': {
                    classPrefix: '',
                    classes: {
                        'hidden': [
                            'hidden'
                        ],
                        'hidden-xs': [
                            'hidden-xs'
                        ],
                        'hidden-sm': [
                            'hidden-sm'
                        ],
                        'hidden-md': [
                            'hidden-md'
                        ],
                        'hidden-lg': [
                            'hidden-lg'
                        ],
                        'hidden-print': [
                            'hidden-print'
                        ]
                    }
                },
                'col': {
                    classPrefix: '',
                    classes: {
                        size: [
                            new RegExp( '^col-(' + sizes.join('|')+ ')-([0-9]|10|11|12)$' )
                        ],
                        offset: [
                            new RegExp( '^col-(' + sizes.join('|')+ ')-(offset)-([0-9]|10|11|12)$' )
                        ],
                        push: [
                            new RegExp( '^col-(' + sizes.join('|')+ ')-(push)-([0-9]|10|11|12)$' )
                        ],
                        pull: [
                            new RegExp( '^col-(' + sizes.join('|')+ ')-(pull)-([0-9])+$' )
                        ]
                    }
                }
            },
            bootstrapElements = {
                'container': {
                    tagName: 'div',
                    classPrefix: '',
                    default: 'container'
                },
                'well': {
                    tagName: 'div',
                    classPrefix: '',
                    default: 'well'
                },
                'container-fluid': {
                    tagName: 'div',
                    classPrefix: '',
                    default: 'container-fluid'
                },
                'row': {
                    tagName: 'div',
                    classPrefix: '',
                    default: 'row'
                },
                'glyphicon': {
                    tagName: 'span',
                    classPrefix: 'glyphicon-',
                    attributes: {
                        'aria-hidden': 'true'
                    },
                    classes: {
                        type: ('asterisk plus euro eur minus cloud envelope pencil '
                            + 'glass music search heart star star-empty user film '
                            + 'th-large th th-list ok remove zoom-in zoom-out off '
                            + 'signal cog trash home file time road download-alt '
                            + 'download upload inbox circle repeat refresh list-alt lock '
                            + 'flag headphones volume-off volume-down volume-up qrcode barcode tag '
                            + 'tags book bookmark print camera font bold italic '
                            + 'height width align-left align-center align-right align-justify list indent-left '
                            + 'indent-right facetime-video picture marker adjust tint edit share '
                            + 'check move step-backward fast-backward backward play pause stop '
                            + 'forward fast-forward step-forward eject chevron-left chevron-right plus-sign minus-sign '
                            + 'remove-sign ok-sign question-sign info-sign screenshot remove-circle ok-circle ban-circle '
                            + 'arrow-left arrow-right arrow-up arrow-down share-alt resize-full resize-small exclamation-sign '
                            + 'gift leaf fire eye-open eye-close warning-sign plane calendar '
                            + 'random comment magnet chevron-up chevron-down retweet shopping-cart folder-close '
                            + 'folder-open resize-vertical resize-horizontal hdd bullhorn bell certificate thumbs-up '
                            + 'thumbs-down hand-right hand-left hand-up hand-down circle-arrow-right circle-arrow-left circle-arrow-up '
                            + 'circle-arrow-down globe wrench tasks filter briefcase fullscreen dashboard '
                            + 'paperclip heart-empty link phone pushpin usd gbp sort '
                            + 'sort-by-alphabet sort-by-alphabet-alt sort-by-order sort-by-order-alt sort-by-attributes sort-by-attributes-alt unchecked expand '
                            + 'collapse-down collapse-up log-in flash log-out new-window record save '
                            + 'open save import export send floppy-disk floppy-saved floppy-remove '
                            + 'floppy-save floppy-open credit-card transfer cutlery header compressed earphone '
                            + 'phone-alt tower stats sd-video hd-video subtitles sound-stereo sound-dolby '
                            + 'sound-5-1 sound-6-1 sound-7-1 copyright-mark registration-mark cloud-download cloud-upload tree-conifer '
                            + 'tree-deciduous cd save-file open-file level-up copy paste alert '
                            + 'equalizer king queen pawn bishop knight baby-formula tent '
                            + 'blackboard bed apple erase hourglass lamp duplicate piggy-bank '
                            + 'scissors bitcoin btc xbt yen jpy ruble rub '
                            + 'scale ice-lolly ice-lolly-tasted education option-horizontal option-vertical menu-hamburger modal-window '
                            + 'oil grain sunglasses text-size text-color text-background object-align-top object-align-bottom '
                            + 'object-align-horizontal object-align-left object-align-vertical object-align-right triangle-right triangle-left triangle-bottom triangle-top '
                            + 'console superscript subscript menu-left menu-right menu-down menu-up'
                            ).split(' ')
                    }
                },
                'img': {
                    tagName: 'img',
                    classPrefix: 'img-',
                    attributes: {
                        src: '',
                        alt: ''
                    },
                    classes: {
                        responsive: [
                            'responsive'
                        ]
                    }
                },
                'btn': {
                    tagName: 'button',
                    classPrefix: 'btn-',
                    default: 'btn-default',
                    attributes: {},
                    classes: {
                        block: [
                            'block'
                        ],
                        size: [
                            'lg',
                            'md',
                            'sm',
                            'xs'
                        ],
                        type: [
                            'default',
                            'primary',
                            'success',
                            'info',
                            'warning',
                            'danger'
                        ]
                    }
                },
                'panel': {
                    tagName: 'div',
                    classPrefix: 'panel-',
                    default: 'panel panel-default',
                    attributes: {},
                    classes: {
                        type: [
                            'default',
                            'primary',
                            'success',
                            'info',
                            'warning',
                            'danger'
                        ]
                    }
                },
                'panel-heading': {
                    tagName: 'div',
                    default: 'panel-heading'
                },
                'panel-title': {
                    tagName: 'span',
                    default: 'panel-title'
                },
                'panel-body': {
                    tagName: 'div',
                    default: 'panel-body'
                },
                'panel-footer': {
                    tagName: 'div',
                    default: 'panel-footer'
                }
            },
            classTemplate = '[class~="{bootstrapClass}"]',
            allSelector = '';
        
        // construct css selector that returns all bootstrap specific nodes
        Object
            .keys( bootstrapElements )
            .forEach(
                function( pElementName ){
                    allSelector +=
                        (allSelector.length ? ',' : '')
                        + tb.parse( classTemplate, { bootstrapClass: pElementName } );
                }
            );
        
        // constructor
        function Bootstrap(){
            var that = this,
                bte = {},
                config = {},
                classes,
                parent,
                target,
                name;

            // 1..3 arguments can be given in any order, at least one argument is mandatory
            // if string: bootstrap element name ( -> identifying class )
            // if object: bootstrap config object
            // if DOM node: target

            // process arguments
            [].forEach.call(
                arguments,
                function( pArg ){
                    if ( pArg instanceof Object ){
                        if ( pArg instanceof Element ){
                            target = pArg;
                        } else {
                            config = pArg;
                        }

                    } else if( typeof pArg === 'string' ){
                        name = pArg;
                    }
                }
            );

            // analyze missing parms, aquire from existing DOM element when possible

            // ...target missing
            if ( !target ){
                if ( !!config && !!config.tagName ){ //config tagName given

                    target = document.createElement( config.tagName );

                }
            }

            // ... target given
            if ( !!target ){

                if (
                    name                                   // name given
                    && bootstrapElements[ name ]           // bt element with this name exists
                    && !tb.dom( target ).hasClass( name ) // target does not have that class
                ){

                    // create bt element by setting default classes
                    tb.dom( target )
                        .addClass( bootstrapElements[ name ].default );

                } else {

                    // try to extract element name from classes defined in target element
                    Object
                        .keys( bootstrapElements )
                        .forEach(
                            function( pElement ){

                                if ( tb.dom( target ).hasClass( pElement ) ){
                                    if ( !name ){
                                        name = pElement;
                                    } else {
                                        console.warn( 'Warning: bootstrap element', name,
                                            'already defined when encountering', pElement,
                                            ' in constructor - ignoring', pElement);
                                    }
                                }

                            }
                        );

                }

                // bootstrap element definition
                bte = bootstrapElements[name];
            }

            // ...name exists - add default values
            if ( !!name ){

                // add default attributes
                if ( !!bte.attributes ){
                    tb.dom( target ).attr( bte.attributes || {} );
                }

                // add attributes given in config
                if ( !!config.attributes ){
                    tb.dom( target ).attr( config.attributes );
                }

            }

            // get parent element
            parent = tb.dom( that.target )
                .parents()
                .map(
                    function( pElement ){
                        if ( pElement.matches( allSelector ) ){
                            return true;
                        }
                    }
                );

            parent = !parent[0] ? undefined : parent[0];

            // target property
            Object.defineProperty(
                this,
                'target',
                {
                    enumerable: true,
                    value: target
                }
            );

            // name property
            Object.defineProperty(
                this,
                'name',
                {
                    writable: true,
                    enumerable: true,
                    value: name
                }
            );

            // non-live children list
            Object.defineProperty(
                this,
                'children',
                {
                    enumerable: true,
                    get: getChildren
                }
            );

            // parent element
            Object.defineProperty(
                this,
                'parent',
                {
                    enumerable: true,
                    value: parent
                }
            );

        }

        // prototype
        Bootstrap.prototype = {
         
            namespace: 'tb.bootstrap',
            
            set: set,
            
            get: get,
            
            remove: remove,
            
            state: state
            
        };

        return Bootstrap;

        
        //private functions
        
        function set( pClasses ){
            var that = this,
                bte = that.name ? bootstrapElements[ that.name ] : false,
                classes;

            if ( typeof pClasses === 'string' ){
                classes = pClasses.split(' ');
            } else if ( !( pClasses instanceof Array ) ){
                console.warn( 'Warning: not a valid parameter when calling <bootstrapInstance>.set() -> ',
                    pClasses, ' on element ', that );
                return that;
            }

            classes = pClasses;

            // intermediate hack
            tb.dom( that.target ).addClass( classes );

            return that;
        }

        function get( pWhat ){
            var that = this,
                className = that.target.className,
                result = [];

            className
                .split(' ')
                .forEach(
                    function( pClass ){
                        if ( pWhat.constructor === RegExp ){
                            if ( pClass.matches( pWhat ) ){
                                result.push( pClass );
                            }
                        }
                    }
                );

            return result;
        }

        function remove( pWhat ){
            var that = this,
                className = that.target.className;

            className
                .split(' ')
                .forEach(
                    function( pClass ){
                        if ( pWhat.constructor === RegExp ){
                            if ( pClass.matches( pWhat ) ){
                                tb.dom( that.target ).removeClass( pClass );
                            }
                        }
                    }
                );

            return that;
        }
        
        function getChildren(){
            var that = this,
                result = [],
                id = tb.getId(),
                tempBootstrapClass = tb.getId(),
                selector = tb.dom( allSelector, that.target),
                notSelector = '['+'data-tempid="'+id+'"] .' + tempBootstrapClass + ' *';

            // set temporary id for tb.dom/.querySelectorAll()
            tb.dom( that.target )
                .attr( 'data-tempid', id );

            selector
                .addClass( tempBootstrapClass )
                .not( notSelector ) // not those that are below level 1
                .forEach(
                    function( pDomNode ) {
                        result.push( pDomNode ); // push dom object to result array
                    }
                );

            // remove temporary ids
            tb.dom( that.target )
                .removeAttr( 'data-tempid' );

            tb.dom( '.'+tempBootstrapClass, that.target )
                .removeClass( tempBootstrapClass ); //  remove temporary bootstrap class

            return result;
        }

        function state(){
            var that = this,
                result = {
                    element: { classes: {} },
                    classes: [],
                    helpers: {}
                },
                classes = that.target.className.split( ' ' );
            
            classes
                .forEach(
                    function( pClass ){
                        
                        Object
                            .keys( bootstrapElements )
                            .forEach(

                                function( pKey ){
                                    var thisElement = bootstrapElements[ pKey ],
                                        classPrefix = thisElement.classPrefix || '';

                                    if ( tb.dom( that.target ).hasClass( pKey ) ){

                                        if ( result.classes.indexOf( pKey ) === -1 ){
                                            result.classes.push( pKey );
                                        }

                                        // get bootstrap element specific DOM node attributes
                                        if ( !!thisElement.attributes ){
                                            result.element.attributes = {};

                                            [].forEach.call(
                                                that.target.attributes,
                                                function( pAttribute ){
                                                    if ( !!thisElement.attributes && thisElement.attributes[ pAttribute.name ] ){
                                                        result.element.attributes[ pAttribute.name ] = pAttribute.nodeValue;
                                                    }
                                                }
                                            );

                                            // indicate missing attributes
                                            Object
                                                .keys( thisElement.attributes )
                                                .forEach(
                                                    function( pAttribute ){
                                                        if ( !result.element.attributes[ pAttribute.name ] ){
                                                            result.element.attributes[ pAttribute.name ] = '-MISSING ATTRIBUTE-';
                                                        }
                                                    }
                                                );
                                        }

                                        // get bootstrap element specific classes
                                        Object
                                            .keys( thisElement.classes )
                                            .forEach(
                                                function( pClassGroup ){
                                                    thisElement
                                                        .classes[pClassGroup]
                                                        .forEach(
                                                            function( pClassOption ){
                                                                if (
                                                                    (
                                                                        typeof pClassOption === 'string'
                                                                        && classPrefix + pClassOption === pClass
                                                                    )
                                                                    ||
                                                                    (
                                                                        pClassOption.constructor === RegExp
                                                                        && pClass.match( pClassOption )
                                                                    )
                                                                ){

                                                                    result.classes.push( pClass );
                                                                    result.element.classes[ pClassGroup ] = pClass;

                                                                }
                                                            }
                                                        );
                                                }
                                            );
                                    }

                                }
                            );

                        // get elements helper classes
                        Object
                            .keys( bootstrapHelpers )
                            .forEach(
                                function( pHelper ){
                                    var thisHelper = bootstrapHelpers[ pHelper ],
                                        classPrefix = thisHelper.classPrefix || '';

                                    // get bootstrap helper specific classes
                                    Object
                                        .keys( thisHelper.classes )
                                        .forEach(
                                            function( pClassGroup ){
                                                thisHelper
                                                    .classes[pClassGroup]
                                                    .forEach(
                                                        function( pClassOption ){
                                                            if (
                                                                (
                                                                    typeof pClassOption === 'string'
                                                                    && classPrefix + pClassOption === pClass
                                                                )
                                                                ||
                                                                (
                                                                    pClassOption.constructor === RegExp
                                                                    && pClass.match( pClassOption )
                                                                )
                                                            ){

                                                                result.helpers[ pHelper ] =
                                                                    result.helpers[ pHelper ] || {};
                                                                result.helpers[ pHelper ][ pClassGroup ] =
                                                                    result.helpers[ pHelper ][ pClassGroup ] || '';
                                                                result.helpers[ pHelper ][ pClassGroup ] +=
                                                                    (result.helpers[ pHelper ][ pClassGroup ].length ? ' ' : '')
                                                                    + pClass;

                                                                result.classes.push( pClass );

                                                            }
                                                        }
                                                    );
                                            }
                                        );

                                }
                            );
                    }
                );

            return result;
        }

    })()

);

tb.plugin( 'bootstrap', function bootstrap(){
    var that = this;

    [].unshift.call( arguments, tb.Bootstrap );
    [].unshift.call( arguments, that.target );

    return new (
        tb.Bootstrap.bind.apply(
            tb.Bootstrap,
            arguments
        ))();
});
